/* clearAllInputVariables - does what it sounds like.  Clears b0 through b15
 */
 

__device__ inline void clearB0toB15(UINT4 &b0, UINT4 &b1, UINT4 &b2, UINT4 &b3, UINT4 &b4, UINT4 &b5, UINT4 &b6, UINT4 &b7, 
			   UINT4 &b8, UINT4 &b9, UINT4 &b10, UINT4 &b11, UINT4 &b12, UINT4 &b13, UINT4 &b14, UINT4 &b15) {
  b0 = 0x00000000;
  b1 = 0x00000000;
  b2 = 0x00000000;
  b3 = 0x00000000;
  b4 = 0x00000000;
  b5 = 0x00000000;
  b6 = 0x00000000;
  b7 = 0x00000000;
  b8 = 0x00000000;
  b9 = 0x00000000;
  b10 = 0x00000000;
  b11 = 0x00000000;
  b12 = 0x00000000;
  b13 = 0x00000000;
  b14 = 0x00000000;
  b15 = 0x00000000;  
}

__device__ inline void copyCharsetAndBitmap(unsigned char *sharedCharset, unsigned char *sharedBitmap, unsigned char *sharedLengths, int charsetLen, int pass_length) {
  uint64_t *sharedCharsetCoalesce = (uint64_t *)sharedCharset;
  uint64_t *deviceCharsetCoalesce = (uint64_t *)deviceCharset;
  
  uint64_t *sharedBitmapCoalesce = (uint64_t *)sharedBitmap;
  uint64_t *deviceBitmapCoalesce = (uint64_t *)constantBitmap;  
  

    
  int a, b;
  // This has to be alignable somehow...
  for (a = 0; a < 16; a++) {
    sharedLengths[a] = charsetLengths[a];  
  }
  
  for (b = 0; b < pass_length; b++) {
    for (a = 0; a <= (charsetLengths[b] / 8); a++) {
      sharedCharsetCoalesce[a + (b * 32)] = deviceCharsetCoalesce[a + (b * 32)];
    }
  }
  for (a = 0; a <= (8192 / 8); a++) {
    sharedBitmapCoalesce[a] = deviceBitmapCoalesce[a];
  }
}


__device__ inline void copyCharsetFAST(unsigned char *sharedCharset, int charsetLen) {
  uint64_t *sharedCharsetCoalesce = (uint64_t *)sharedCharset;
  uint64_t *deviceCharsetCoalesce = (uint64_t *)deviceCharset;
    
  int a;
    for (a = 0; a <= (charsetLen / 8); a++) {
      sharedCharsetCoalesce[a] = deviceCharsetCoalesce[a];
    }
}

// Loads start positions.  Should work on all hashes.
__device__ inline void loadStartPositions(int count, uint32_t &thread_index, struct start_positions *DEVICE_Start_Positions, 
		unsigned char &p0, unsigned char &p1, unsigned char &p2, unsigned char &p3, 
		unsigned char &p4, unsigned char &p5, unsigned char &p6, unsigned char &p7,
		unsigned char &p8, unsigned char &p9, unsigned char &p10, unsigned char &p11,
		unsigned char &p12, unsigned char &p13, unsigned char &p14, unsigned char &p15) {
  p0 = 0;
  p1 = 0;
  p2 = 0;
  p3 = 0;
  p4 = 0;
  p5 = 0;
  p6 = 0;
  p7 = 0;
  p8 = 0;
  p9 = 0;
  p10 = 0;
  p11 = 0;
  p12 = 0;
  p13 = 0;
  p14 = 0;
  p15 = 0;

  p0 = DEVICE_Start_Positions[thread_index].p0;
  if (count <= 1) return;
  p1 = DEVICE_Start_Positions[thread_index].p1;
  if (count <= 2) return;
  p2 = DEVICE_Start_Positions[thread_index].p2;
  if (count <= 3) return;
  p3 = DEVICE_Start_Positions[thread_index].p3;
  if (count <= 4) return;
  p4 = DEVICE_Start_Positions[thread_index].p4;
  if (count <= 5) return;
  p5 = DEVICE_Start_Positions[thread_index].p5;
  if (count <= 6) return;
  p6 = DEVICE_Start_Positions[thread_index].p6;
  if (count <= 7) return;
  p7 = DEVICE_Start_Positions[thread_index].p7;
  if (count <= 8) return;
  p8 = DEVICE_Start_Positions[thread_index].p8;
  if (count <= 9) return;
  p9 = DEVICE_Start_Positions[thread_index].p9;
  if (count <= 10) return;
  p10 = DEVICE_Start_Positions[thread_index].p10;
  if (count <= 11) return;
  p11 = DEVICE_Start_Positions[thread_index].p11;
  if (count <= 12) return;
  p12 = DEVICE_Start_Positions[thread_index].p12;
  if (count <= 13) return;
  p13 = DEVICE_Start_Positions[thread_index].p13;
  if (count <= 14) return;
  p14 = DEVICE_Start_Positions[thread_index].p14;
  if (count <= 15) return;
  p15 = DEVICE_Start_Positions[thread_index].p15;
  if (count <= 16) return;
}

// initMD loads the charset values into the working blocks for MD4/MD5
// length : length in bytes to load
__device__ inline void initMD(int length, unsigned char *sharedCharset,
		unsigned char &p0, unsigned char &p1, unsigned char &p2, unsigned char &p3, 
		unsigned char &p4, unsigned char &p5, unsigned char &p6, unsigned char &p7,
		unsigned char &p8, unsigned char &p9, unsigned char &p10, unsigned char &p11,
		unsigned char &p12, unsigned char &p13, unsigned char &p14, unsigned char &p15,
		UINT4 &b0, UINT4 &b1, UINT4 &b2, UINT4 &b3, UINT4 &b4, UINT4 &b5, UINT4 &b6, UINT4 &b7, 
		UINT4 &b8, UINT4 &b9, UINT4 &b10, UINT4 &b11, UINT4 &b12, UINT4 &b13, UINT4 &b14, UINT4 &b15) {

  clearB0toB15(b0, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15);

  // Set length properly (length in bits)
  b14 = length * 8;
  
  if (length == 0) {
    b0 |= 0x00000080;
    return;
  }  
  b0 |= sharedCharset[p0];
  if (length == 1) {
    b0 |= 0x00008000;
    return;
  }
  b0 |= sharedCharset[p1 + 256] << 8;
  if (length == 2) {
    b0 |= 0x00800000;
    return;
  }
  b0 |= sharedCharset[p2 + 512] << 16;
  if (length == 3) {
    b0 |= 0x80000000;
    return;
  }
  b0 |= sharedCharset[p3 + 768] << 24;	
  if (length == 4) {
    b1 |= 0x00000080;
    return;
  }
  b1 |= sharedCharset[p4 + 1024];
  if (length == 5) {
    b1 |= 0x00008000;
    return;
  }
  b1 |= sharedCharset[p5 + (256 * 5)] << 8;	
  if (length == 6) {
    b1 |= 0x00800000;
    return;
  }
  b1 |= sharedCharset[p6 + (256 * 6)] << 16;
  if (length == 7) {
    b1 |= 0x80000000;
    return;
  }
  b1 |= sharedCharset[p7 + (256 * 7)] << 24;	
  if (length == 8) {
    b2 |= 0x00000080;
    return;
  }
  b2 |= sharedCharset[p8 + (256 * 8)];
  if (length == 9) {
    b2 |= 0x00008000;
    return;
  }
  b2 |= sharedCharset[p9 + (256 * 9)] << 8;		
  if (length == 10) {
    b2 |= 0x00800000;
    return;
  }
  b2 |= sharedCharset[p10 + (256 * 10)] << 16;
  if (length == 11) {
   b2 |= 0x80000000;
    return;
  }
  b2 |= sharedCharset[p11 + (256 * 11)] << 24;	
  if (length == 12) {
    b3 |= 0x00000080;
    return;
  }
  b3 |= sharedCharset[p12 + (256 * 12)];
  if (length == 13) {
    b3 |= 0x00008000;
    return;
  }
  b3 |= sharedCharset[p13 + (256 * 13)] << 8;	
  if (length == 14) {
    b3 |= 0x00800000;
    return;
  }   
  b3 |= sharedCharset[p14 + (256 * 14)] << 16;	
  if (length == 15) {
    b3 |= 0x80000000;
    return;
  } 
  b3 |= sharedCharset[p15 + (256 * 15)] << 24;	
  if (length == 16) {
    b4 |= 0x00000080;
    return;
  } 	
}


// initMD loads the charset values into the working blocks for MD4/MD5
// length : length in bytes to load
__device__ inline void initMDFAST(int length, unsigned char *sharedCharset,
		unsigned char &p0, unsigned char &p1, unsigned char &p2, unsigned char &p3, 
		unsigned char &p4, unsigned char &p5, unsigned char &p6, unsigned char &p7,
		unsigned char &p8, unsigned char &p9, unsigned char &p10, unsigned char &p11,
		unsigned char &p12, unsigned char &p13, unsigned char &p14, unsigned char &p15,
		UINT4 &b0, UINT4 &b1, UINT4 &b2, UINT4 &b3, UINT4 &b4, UINT4 &b5, UINT4 &b6, UINT4 &b7, 
		UINT4 &b8, UINT4 &b9, UINT4 &b10, UINT4 &b11, UINT4 &b12, UINT4 &b13, UINT4 &b14, UINT4 &b15) {

  clearB0toB15(b0, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15);

  // Set length properly (length in bits)
  b14 = length * 8;
  
  if (length == 0) {
    b0 |= 0x00000080;
    return;
  }  
  b0 |= sharedCharset[p0];
  if (length == 1) {
    b0 |= 0x00008000;
    return;
  }
  b0 |= sharedCharset[p1] << 8;
  if (length == 2) {
    b0 |= 0x00800000;
    return;
  }
  b0 |= sharedCharset[p2] << 16;
  if (length == 3) {
    b0 |= 0x80000000;
    return;
  }
  b0 |= sharedCharset[p3] << 24;	
  if (length == 4) {
    b1 |= 0x00000080;
    return;
  }
  b1 |= sharedCharset[p4];
  if (length == 5) {
    b1 |= 0x00008000;
    return;
  }
  b1 |= sharedCharset[p5] << 8;	
  if (length == 6) {
    b1 |= 0x00800000;
    return;
  }
  b1 |= sharedCharset[p6] << 16;
  if (length == 7) {
    b1 |= 0x80000000;
    return;
  }
  b1 |= sharedCharset[p7] << 24;	
  if (length == 8) {
    b2 |= 0x00000080;
    return;
  }
  b2 |= sharedCharset[p8];
  if (length == 9) {
    b2 |= 0x00008000;
    return;
  }
  b2 |= sharedCharset[p9] << 8;		
  if (length == 10) {
    b2 |= 0x00800000;
    return;
  }
  b2 |= sharedCharset[p10] << 16;
  if (length == 11) {
   b2 |= 0x80000000;
    return;
  }
  b2 |= sharedCharset[p11] << 24;	
  if (length == 12) {
    b3 |= 0x00000080;
    return;
  }
  b3 |= sharedCharset[p12];
  if (length == 13) {
    b3 |= 0x00008000;
    return;
  }
  b3 |= sharedCharset[p13] << 8;	
  if (length == 14) {
    b3 |= 0x00800000;
    return;
  }   
  b3 |= sharedCharset[p14] << 16;	
  if (length == 15) {
    b3 |= 0x80000000;
    return;
  } 
  b3 |= sharedCharset[p15] << 24;	
  if (length == 16) {
    b4 |= 0x00000080;
    return;
  } 	
}


__device__ inline void initSHA1(int length, unsigned char *sharedCharset,
		unsigned char &p0, unsigned char &p1, unsigned char &p2, unsigned char &p3, 
		unsigned char &p4, unsigned char &p5, unsigned char &p6, unsigned char &p7,
		unsigned char &p8, unsigned char &p9, unsigned char &p10, unsigned char &p11,
		unsigned char &p12, unsigned char &p13, unsigned char &p14, unsigned char &p15,
		UINT4 &b0, UINT4 &b1, UINT4 &b2, UINT4 &b3, UINT4 &b4, UINT4 &b5, UINT4 &b6, UINT4 &b7, 
		UINT4 &b8, UINT4 &b9, UINT4 &b10, UINT4 &b11, UINT4 &b12, UINT4 &b13, UINT4 &b14, UINT4 &b15) {

  clearB0toB15(b0, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15);

  // Set length properly (length in bits)
  b15 = length * 8 << 24;
  
  if (length == 0) {
    b0 |= 0x00000080;
    return;
  }  
  b0 |= sharedCharset[p0];
  if (length == 1) {
    b0 |= 0x00008000;
    return;
  }
  b0 |= sharedCharset[p1 + 256] << 8;
  if (length == 2) {
    b0 |= 0x00800000;
    return;
  }
  b0 |= sharedCharset[p2 + 512] << 16;
  if (length == 3) {
    b0 |= 0x80000000;
    return;
  }
  b0 |= sharedCharset[p3 + 768] << 24;	
  if (length == 4) {
    b1 |= 0x00000080;
    return;
  }
  b1 |= sharedCharset[p4 + 1024];
  if (length == 5) {
    b1 |= 0x00008000;
    return;
  }
  b1 |= sharedCharset[p5 + (256 * 5)] << 8;	
  if (length == 6) {
    b1 |= 0x00800000;
    return;
  }
  b1 |= sharedCharset[p6 + (256 * 6)] << 16;
  if (length == 7) {
    b1 |= 0x80000000;
    return;
  }
  b1 |= sharedCharset[p7 + (256 * 7)] << 24;	
  if (length == 8) {
    b2 |= 0x00000080;
    return;
  }
  b2 |= sharedCharset[p8 + (256 * 8)];
  if (length == 9) {
    b2 |= 0x00008000;
    return;
  }
  b2 |= sharedCharset[p9 + (256 * 9)] << 8;		
  if (length == 10) {
    b2 |= 0x00800000;
    return;
  }
  b2 |= sharedCharset[p10 + (256 * 10)] << 16;
  if (length == 11) {
   b2 |= 0x80000000;
    return;
  }
  b2 |= sharedCharset[p11 + (256 * 11)] << 24;	
  if (length == 12) {
    b3 |= 0x00000080;
    return;
  }
  b3 |= sharedCharset[p12 + (256 * 12)];
  if (length == 13) {
    b3 |= 0x00008000;
    return;
  }
  b3 |= sharedCharset[p13 + (256 * 13)] << 8;	
  if (length == 14) {
    b3 |= 0x00800000;
    return;
  }   
  b3 |= sharedCharset[p14 + (256 * 14)] << 16;	
  if (length == 15) {
    b3 |= 0x80000000;
    return;
  } 
  b3 |= sharedCharset[p15 + (256 * 15)] << 24;	
  if (length == 16) {
    b4 |= 0x00000080;
    return;
  } 	
}


__device__ inline void initSHA1FAST(int length, unsigned char *sharedCharset,
		unsigned char &p0, unsigned char &p1, unsigned char &p2, unsigned char &p3, 
		unsigned char &p4, unsigned char &p5, unsigned char &p6, unsigned char &p7,
		unsigned char &p8, unsigned char &p9, unsigned char &p10, unsigned char &p11,
		unsigned char &p12, unsigned char &p13, unsigned char &p14, unsigned char &p15,
		UINT4 &b0, UINT4 &b1, UINT4 &b2, UINT4 &b3, UINT4 &b4, UINT4 &b5, UINT4 &b6, UINT4 &b7, 
		UINT4 &b8, UINT4 &b9, UINT4 &b10, UINT4 &b11, UINT4 &b12, UINT4 &b13, UINT4 &b14, UINT4 &b15) {

  clearB0toB15(b0, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15);

  // Set length properly (length in bits)
  b15 = length * 8 << 24;
  
  if (length == 0) {
    b0 |= 0x00000080;
    return;
  }  
  b0 |= sharedCharset[p0];
  if (length == 1) {
    b0 |= 0x00008000;
    return;
  }
  b0 |= sharedCharset[p1] << 8;
  if (length == 2) {
    b0 |= 0x00800000;
    return;
  }
  b0 |= sharedCharset[p2] << 16;
  if (length == 3) {
    b0 |= 0x80000000;
    return;
  }
  b0 |= sharedCharset[p3] << 24;	
  if (length == 4) {
    b1 |= 0x00000080;
    return;
  }
  b1 |= sharedCharset[p4];
  if (length == 5) {
    b1 |= 0x00008000;
    return;
  }
  b1 |= sharedCharset[p5] << 8;	
  if (length == 6) {
    b1 |= 0x00800000;
    return;
  }
  b1 |= sharedCharset[p6] << 16;
  if (length == 7) {
    b1 |= 0x80000000;
    return;
  }
  b1 |= sharedCharset[p7] << 24;	
  if (length == 8) {
    b2 |= 0x00000080;
    return;
  }
  b2 |= sharedCharset[p8];
  if (length == 9) {
    b2 |= 0x00008000;
    return;
  }
  b2 |= sharedCharset[p9] << 8;		
  if (length == 10) {
    b2 |= 0x00800000;
    return;
  }
  b2 |= sharedCharset[p10] << 16;
  if (length == 11) {
   b2 |= 0x80000000;
    return;
  }
  b2 |= sharedCharset[p11] << 24;	
  if (length == 12) {
    b3 |= 0x00000080;
    return;
  }
  b3 |= sharedCharset[p12];
  if (length == 13) {
    b3 |= 0x00008000;
    return;
  }
  b3 |= sharedCharset[p13] << 8;	
  if (length == 14) {
    b3 |= 0x00800000;
    return;
  }   
  b3 |= sharedCharset[p14] << 16;	
  if (length == 15) {
    b3 |= 0x80000000;
    return;
  } 
  b3 |= sharedCharset[p15] << 24;	
  if (length == 16) {
    b4 |= 0x00000080;
    return;
  } 	
}

// length : length in bytes to load
__device__ inline void initNTLM(int length, unsigned char *sharedCharset,
		unsigned char &p0, unsigned char &p1, unsigned char &p2, unsigned char &p3, 
		unsigned char &p4, unsigned char &p5, unsigned char &p6, unsigned char &p7,
		unsigned char &p8, unsigned char &p9, unsigned char &p10, unsigned char &p11,
		unsigned char &p12, unsigned char &p13, unsigned char &p14, unsigned char &p15,
		UINT4 &b0, UINT4 &b1, UINT4 &b2, UINT4 &b3, UINT4 &b4, UINT4 &b5, UINT4 &b6, UINT4 &b7, 
		UINT4 &b8, UINT4 &b9, UINT4 &b10, UINT4 &b11, UINT4 &b12, UINT4 &b13, UINT4 &b14, UINT4 &b15) {

  clearB0toB15(b0, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15);

  // Set length properly (length in bits - zero padded unicode, so twice the "password" length)
  b14 = length * 16;
  
  if (length == 0) {
    b0 |= 0x00000080;
    return;
  }  
  b0 |= sharedCharset[p0];
  if (length == 1) {
    b0 |= 0x00800000;
    return;
  }
  b0 |= sharedCharset[p1 + 256] << 16;
  if (length == 2) {
    b1 |= 0x00000080;
	return;
  }
  b1 |= sharedCharset[p2 + 512];
  if (length == 3) {
    b1 |= 0x00800000;
    return;
  }
  b1 |= sharedCharset[p3 + 768] << 16;	
  if (length == 4) {
    b2 |= 0x00000080;
    return;
  }
  b2 |= sharedCharset[p4 + 1024];
  if (length == 5) {
    b2 |= 0x00800000;
    return;
  }
  b2 |= sharedCharset[p5 + (256 * 5)] << 16;	
  if (length == 6) {
    b3 |= 0x00000080;
    return;
  }
  b3 |= sharedCharset[p6 + (256 * 6)];
  if (length == 7) {
    b3 |= 0x00800000;
    return;
  }
  b3 |= sharedCharset[p7 + (256 * 7)] << 16;	
  if (length == 8) {
    b4 |= 0x00000080;
    return;
  }
  b4 |= sharedCharset[p8 + (256 * 8)];
  if (length == 9) {
    b4 |= 0x00800000;
    return;
  }
  b4 |= sharedCharset[p9 + (256 * 9)] << 16;		
  if (length == 10) {
    b5 |= 0x00000080;
    return;
  }
  b5 |= sharedCharset[p10 + (256 * 10)];
  if (length == 11) {
   b5 |= 0x00800000;
    return;
  }
  b5 |= sharedCharset[p11 + (256 * 11)] << 16;	
  if (length == 12) {
    b6 |= 0x00000080;
    return;
  }
  b6 |= sharedCharset[p12 + (256 * 12)];
  if (length == 13) {
    b6 |= 0x00800000;
    return;
  }
  b6 |= sharedCharset[p13 + (256 * 13)] << 16;	
  if (length == 14) {
    b7 |= 0x00000080;
    return;
  }   
  b7 |= sharedCharset[p14 + (256 * 14)];	
  if (length == 15) {
    b7 |= 0x00800000;
    return;
  } 
  b7 |= sharedCharset[p15 + (256 * 15)] << 16;	
  if (length == 16) {
    b8 |= 0x00000080;
    return;
  } 	
}


// length : length in bytes to load
__device__ inline void initNTLMFAST(int length, unsigned char *sharedCharset,
		unsigned char &p0, unsigned char &p1, unsigned char &p2, unsigned char &p3, 
		unsigned char &p4, unsigned char &p5, unsigned char &p6, unsigned char &p7,
		unsigned char &p8, unsigned char &p9, unsigned char &p10, unsigned char &p11,
		unsigned char &p12, unsigned char &p13, unsigned char &p14, unsigned char &p15,
		UINT4 &b0, UINT4 &b1, UINT4 &b2, UINT4 &b3, UINT4 &b4, UINT4 &b5, UINT4 &b6, UINT4 &b7, 
		UINT4 &b8, UINT4 &b9, UINT4 &b10, UINT4 &b11, UINT4 &b12, UINT4 &b13, UINT4 &b14, UINT4 &b15) {

  clearB0toB15(b0, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15);

  // Set length properly (length in bits - zero padded unicode, so twice the "password" length)
  b14 = length * 16;
  
  if (length == 0) {
    b0 |= 0x00000080;
    return;
  }  
  b0 |= sharedCharset[p0];
  if (length == 1) {
    b0 |= 0x00800000;
    return;
  }
  b0 |= sharedCharset[p1] << 16;
  if (length == 2) {
    b1 |= 0x00000080;
	return;
  }
  b1 |= sharedCharset[p2];
  if (length == 3) {
    b1 |= 0x00800000;
    return;
  }
  b1 |= sharedCharset[p3] << 16;	
  if (length == 4) {
    b2 |= 0x00000080;
    return;
  }
  b2 |= sharedCharset[p4];
  if (length == 5) {
    b2 |= 0x00800000;
    return;
  }
  b2 |= sharedCharset[p5] << 16;	
  if (length == 6) {
    b3 |= 0x00000080;
    return;
  }
  b3 |= sharedCharset[p6];
  if (length == 7) {
    b3 |= 0x00800000;
    return;
  }
  b3 |= sharedCharset[p7] << 16;	
  if (length == 8) {
    b4 |= 0x00000080;
    return;
  }
  b4 |= sharedCharset[p8];
  if (length == 9) {
    b4 |= 0x00800000;
    return;
  }
  b4 |= sharedCharset[p9] << 16;		
  if (length == 10) {
    b5 |= 0x00000080;
    return;
  }
  b5 |= sharedCharset[p10];
  if (length == 11) {
   b5 |= 0x00800000;
    return;
  }
  b5 |= sharedCharset[p11] << 16;	
  if (length == 12) {
    b6 |= 0x00000080;
    return;
  }
  b6 |= sharedCharset[p12];
  if (length == 13) {
    b6 |= 0x00800000;
    return;
  }
  b6 |= sharedCharset[p13] << 16;	
  if (length == 14) {
    b7 |= 0x00000080;
    return;
  }   
  b7 |= sharedCharset[p14];	
  if (length == 15) {
    b7 |= 0x00800000;
    return;
  } 
  b7 |= sharedCharset[p15] << 16;	
  if (length == 16) {
    b8 |= 0x00000080;
    return;
  } 	
}

__device__ inline void checkHash(int pass_length, unsigned char *sharedBitmap, unsigned char *DEVICE_HashTable, uint32_t numberOfPasswords,
		uint32_t *DEVICE_Hashes_32, unsigned char *success, unsigned char *OutputPassword,
		unsigned char p0, unsigned char p1, unsigned char p2, unsigned char p3, 
		unsigned char p4, unsigned char p5, unsigned char p6, unsigned char p7,
		unsigned char p8, unsigned char p9, unsigned char p10, unsigned char p11,
		unsigned char p12, unsigned char p13, unsigned char p14, unsigned char p15,
		UINT4 a, UINT4 b, UINT4 c, UINT4 d,
		uint32_t &search_index, uint32_t &search_high, uint32_t &search_low, uint32_t &hash_order_a, 
		uint32_t &hash_order_mem, uint32_t &temp) {
  //uint32_t search_index, search_high, search_low, hash_order_a, hash_order_mem, temp;
  if ((sharedBitmap[(a & 0x0000ffff) >> 3] >> (a & 0x00000007)) & 0x00000001) {
  if (hashTableShift == 32 || ((DEVICE_HashTable[(b >> hashTableShift) >> 3] >> ((b >> hashTableShift) & 0x00000007)) & 0x01)) {
  // Init binary search through global password space
  search_high = numberOfPasswords;
  search_low = 0;
  search_index = 0;
  while (search_low < search_high) {
    // Midpoint between search_high and search_low
    search_index = search_low + (search_high - search_low) / 2;
    // reorder from low endian to big endian for searching, as hashes are sorted by byte.
    temp = DEVICE_Hashes_32[4 * search_index];    
    hash_order_mem = (temp & 0xff) << 24 | ((temp >> 8) & 0xff) << 16 | ((temp >> 16) & 0xff) << 8 | ((temp >> 24) & 0xff);
    hash_order_a = (a & 0xff) << 24 | ((a >> 8) & 0xff) << 16 | ((a >> 16) & 0xff) << 8 | ((a >> 24) & 0xff);

    // Adjust search_high & search_low to work through space
    if (hash_order_mem < hash_order_a) {
      search_low = search_index + 1;
    } else  {
      search_high = search_index;
    } 
    if ((hash_order_a == hash_order_mem) && (search_low < numberOfPasswords)) {
      // Break out of the search loop - search_index is on a value
      break;
    } 
  }

  // Yes - it's a goto.  And it speeds up performance significantly (15%).
  // It stays.  These values are already loaded.  If they are not the same,
  // there is NO point to touching global memory again.
  if (hash_order_a != hash_order_mem) {
    goto next;
  }
  // We've broken out of the loop, search_index should be on a matching value
  // Loop while the search index is the same - linear search through this to find all possible
  // matching passwords.
  // We first need to move backwards to the beginning, as we may be in the middle of a set of matching hashes.
  // If we are index 0, do NOT subtract, as we will wrap and this goes poorly.
  
  while (search_index && (a == DEVICE_Hashes_32[(search_index - 1) * 4])) {
    search_index--;
  }
  
  while ((a == DEVICE_Hashes_32[search_index * 4])) {
  if (a == DEVICE_Hashes_32[search_index * 4]) {
    if (b == DEVICE_Hashes_32[search_index * 4 + 1]) {
      if (c == DEVICE_Hashes_32[search_index * 4 + 2]) {
        if (d == DEVICE_Hashes_32[search_index * 4 + 3]) {
        
        if (pass_length >= 1) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 0] = deviceCharset[p0];
        if (pass_length >= 2) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 1] = deviceCharset[p1];
        if (pass_length >= 3) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 2] = deviceCharset[p2];
        if (pass_length >= 4) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 3] = deviceCharset[p3];
        if (pass_length >= 5) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 4] = deviceCharset[p4];
        if (pass_length >= 6) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 5] = deviceCharset[p5];
        if (pass_length >= 7) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 6] = deviceCharset[p6];
        if (pass_length >= 8) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 7] = deviceCharset[p7];
        if (pass_length >= 9) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 8] = deviceCharset[p8];
        if (pass_length >= 10) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 9] = deviceCharset[p9];
        if (pass_length >= 11) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 10] = deviceCharset[p10];
        if (pass_length >= 12) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 11] = deviceCharset[p11];
        if (pass_length >= 13) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 12] = deviceCharset[p12];
        if (pass_length >= 14) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 13] = deviceCharset[p13];
        if (pass_length >= 15) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 14] = deviceCharset[p14];
        if (pass_length >= 16) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 15] = deviceCharset[p15];
        success[search_index] = (unsigned char) 1;
        }
      }
    }
  }
  search_index++;
  }
  }
  }
  // This is where the goto goes.  Notice the skipping of all the global memory access.
  next:
  ;
}


__device__ inline void checkHashFAST(int pass_length, uint32_t numberOfPasswords,
		uint32_t *DEVICE_Hashes_32, unsigned char *success, unsigned char *OutputPassword,
		unsigned char p0, unsigned char p1, unsigned char p2, unsigned char p3, 
		unsigned char p4, unsigned char p5, unsigned char p6, unsigned char p7,
		unsigned char p8, unsigned char p9, unsigned char p10, unsigned char p11,
		unsigned char p12, unsigned char p13, unsigned char p14, unsigned char p15,
		UINT4 a, UINT4 b, UINT4 c, UINT4 d,
		uint32_t &search_index) {

  search_index = 0;  
  while (search_index < numberOfPasswords) {
  if (a == DEVICE_Hashes_32[search_index * 4]) {
    if (b == DEVICE_Hashes_32[search_index * 4 + 1]) {
      if (c == DEVICE_Hashes_32[search_index * 4 + 2]) {
        if (d == DEVICE_Hashes_32[search_index * 4 + 3]) {
        
        if (pass_length >= 1) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 0] = deviceCharset[p0];
        if (pass_length >= 2) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 1] = deviceCharset[p1];
        if (pass_length >= 3) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 2] = deviceCharset[p2];
        if (pass_length >= 4) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 3] = deviceCharset[p3];
        if (pass_length >= 5) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 4] = deviceCharset[p4];
        if (pass_length >= 6) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 5] = deviceCharset[p5];
        if (pass_length >= 7) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 6] = deviceCharset[p6];
        if (pass_length >= 8) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 7] = deviceCharset[p7];
        if (pass_length >= 9) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 8] = deviceCharset[p8];
        if (pass_length >= 10) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 9] = deviceCharset[p9];
        if (pass_length >= 11) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 10] = deviceCharset[p10];
        if (pass_length >= 12) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 11] = deviceCharset[p11];
        if (pass_length >= 13) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 12] = deviceCharset[p12];
        if (pass_length >= 14) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 13] = deviceCharset[p13];
        if (pass_length >= 15) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 14] = deviceCharset[p14];
        if (pass_length >= 16) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 15] = deviceCharset[p15];
        success[search_index] = (unsigned char) 1;
        }
      }
    }
  }
  search_index++;
  }
}

__device__ inline void checkHashMulti(int pass_length, unsigned char *sharedBitmap, unsigned char *DEVICE_HashTable, uint32_t numberOfPasswords,
		uint32_t *DEVICE_Hashes_32, unsigned char *success, unsigned char *OutputPassword,
		unsigned char p0, unsigned char p1, unsigned char p2, unsigned char p3, 
		unsigned char p4, unsigned char p5, unsigned char p6, unsigned char p7,
		unsigned char p8, unsigned char p9, unsigned char p10, unsigned char p11,
		unsigned char p12, unsigned char p13, unsigned char p14, unsigned char p15,
		UINT4 a, UINT4 b, UINT4 c, UINT4 d,
		uint32_t &search_index, uint32_t &search_high, uint32_t &search_low, uint32_t &hash_order_a, 
		uint32_t &hash_order_mem, uint32_t &temp) {
  //uint32_t search_index, search_high, search_low, hash_order_a, hash_order_mem, temp;
  if ((sharedBitmap[(a & 0x0000ffff) >> 3] >> (a & 0x00000007)) & 0x00000001) {
  if (hashTableShift == 32 || ((DEVICE_HashTable[(b >> hashTableShift) >> 3] >> ((b >> hashTableShift) & 0x00000007)) & 0x01)) {
  // Init binary search through global password space

  search_high = numberOfPasswords;
  search_low = 0;
  search_index = 0;
  while (search_low < search_high) {
    // Midpoint between search_high and search_low
    search_index = search_low + (search_high - search_low) / 2;
    // reorder from low endian to big endian for searching, as hashes are sorted by byte.
    temp = DEVICE_Hashes_32[4 * search_index];    
    hash_order_mem = (temp & 0xff) << 24 | ((temp >> 8) & 0xff) << 16 | ((temp >> 16) & 0xff) << 8 | ((temp >> 24) & 0xff);
    hash_order_a = (a & 0xff) << 24 | ((a >> 8) & 0xff) << 16 | ((a >> 16) & 0xff) << 8 | ((a >> 24) & 0xff);

    // Adjust search_high & search_low to work through space
    if (hash_order_mem < hash_order_a) {
      search_low = search_index + 1;
    } else  {
      search_high = search_index;
    } 
    if ((hash_order_a == hash_order_mem) && (search_low < numberOfPasswords)) {
      // Break out of the search loop - search_index is on a value
      break;
    } 
  }

  // Yes - it's a goto.  And it speeds up performance significantly (15%).
  // It stays.  These values are already loaded.  If they are not the same,
  // there is NO point to touching global memory again.
  if (hash_order_a != hash_order_mem) {
    goto next;
  }
  // We've broken out of the loop, search_index should be on a matching value
  // Loop while the search index is the same - linear search through this to find all possible
  // matching passwords.
  // We first need to move backwards to the beginning, as we may be in the middle of a set of matching hashes.
  // If we are index 0, do NOT subtract, as we will wrap and this goes poorly.
  
  while (search_index && (a == DEVICE_Hashes_32[(search_index - 1) * 4])) {
    search_index--;
  }

  
  while ((a == DEVICE_Hashes_32[search_index * 4])) {
  if (a == DEVICE_Hashes_32[search_index * 4]) {
    if (b == DEVICE_Hashes_32[search_index * 4 + 1]) {
      if (c == DEVICE_Hashes_32[search_index * 4 + 2]) {
        if (d == DEVICE_Hashes_32[search_index * 4 + 3]) {
        if (pass_length >= 1) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 0] = deviceCharset[p0];
        if (pass_length >= 2) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 1] = deviceCharset[p1 + (256 * 1)];
        if (pass_length >= 3) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 2] = deviceCharset[p2 + (256 * 2)];
        if (pass_length >= 4) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 3] = deviceCharset[p3 + (256 * 3)];
        if (pass_length >= 5) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 4] = deviceCharset[p4 + (256 * 4)];
        if (pass_length >= 6) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 5] = deviceCharset[p5 + (256 * 5)];
        if (pass_length >= 7) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 6] = deviceCharset[p6 + (256 * 6)];
        if (pass_length >= 8) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 7] = deviceCharset[p7 + (256 * 7)];
        if (pass_length >= 9) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 8] = deviceCharset[p8 + (256 * 8)];
        if (pass_length >= 10) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 9] = deviceCharset[p9 + (256 * 9)];
        if (pass_length >= 11) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 10] = deviceCharset[p10 + (256 * 10)];
        if (pass_length >= 12) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 11] = deviceCharset[p11 + (256 * 11)];
        if (pass_length >= 13) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 12] = deviceCharset[p12 + (256 * 12)];
        if (pass_length >= 14) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 13] = deviceCharset[p13 + (256 * 13)];
        if (pass_length >= 15) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 14] = deviceCharset[p14 + (256 * 14)];
        if (pass_length >= 16) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 15] = deviceCharset[p15 + (256 * 15)];
        success[search_index] = (unsigned char) 1;
        }
      }
    }
  }
  search_index++;
  }
  }
  }
  // This is where the goto goes.  Notice the skipping of all the global memory access.
  next:
  ;
}


__device__ inline void checkHashMultiSHA1(int pass_length, unsigned char *sharedBitmap, unsigned char *DEVICE_HashTable, uint32_t numberOfPasswords,
		uint32_t *DEVICE_Hashes_32, unsigned char *success, unsigned char *OutputPassword,
		unsigned char p0, unsigned char p1, unsigned char p2, unsigned char p3, 
		unsigned char p4, unsigned char p5, unsigned char p6, unsigned char p7,
		unsigned char p8, unsigned char p9, unsigned char p10, unsigned char p11,
		unsigned char p12, unsigned char p13, unsigned char p14, unsigned char p15,
		UINT4 a, UINT4 b, UINT4 c, UINT4 d, UINT4 e,
		uint32_t &search_index, uint32_t &search_high, uint32_t &search_low, uint32_t &hash_order_a, 
		uint32_t &hash_order_mem, uint32_t &temp) {
  //uint32_t search_index, search_high, search_low, hash_order_a, hash_order_mem, temp;
  if ((sharedBitmap[(a & 0x0000ffff) >> 3] >> (a & 0x00000007)) & 0x00000001) {
  if ((!DEVICE_HashTable) || (DEVICE_HashTable && (DEVICE_HashTable[a >> 3] >> (a & 0x00000007)) & 0x00000001)) {
  // Init binary search through global password space

  search_high = numberOfPasswords;
  search_low = 0;
  search_index = 0;
  while (search_low < search_high) {
    // Midpoint between search_high and search_low
    search_index = search_low + (search_high - search_low) / 2;
    // reorder from low endian to big endian for searching, as hashes are sorted by byte.
    temp = DEVICE_Hashes_32[5 * search_index];    
    hash_order_mem = (temp & 0xff) << 24 | ((temp >> 8) & 0xff) << 16 | ((temp >> 16) & 0xff) << 8 | ((temp >> 24) & 0xff);
    hash_order_a = (a & 0xff) << 24 | ((a >> 8) & 0xff) << 16 | ((a >> 16) & 0xff) << 8 | ((a >> 24) & 0xff);

    // Adjust search_high & search_low to work through space
    if (hash_order_mem < hash_order_a) {
      search_low = search_index + 1;
    } else  {
      search_high = search_index;
    } 
    if ((hash_order_a == hash_order_mem) && (search_low < numberOfPasswords)) {
      // Break out of the search loop - search_index is on a value
      break;
    } 
  }

  // Yes - it's a goto.  And it speeds up performance significantly (15%).
  // It stays.  These values are already loaded.  If they are not the same,
  // there is NO point to touching global memory again.
  if (hash_order_a != hash_order_mem) {
    goto next;
  }
  // We've broken out of the loop, search_index should be on a matching value
  // Loop while the search index is the same - linear search through this to find all possible
  // matching passwords.
  // We first need to move backwards to the beginning, as we may be in the middle of a set of matching hashes.
  // If we are index 0, do NOT subtract, as we will wrap and this goes poorly.
  
  while (search_index && (a == DEVICE_Hashes_32[(search_index - 1) * 5])) {
    search_index--;
  }

  
  while ((a == DEVICE_Hashes_32[search_index * 5])) {
  if (a == DEVICE_Hashes_32[search_index * 5]) {
    if (b == DEVICE_Hashes_32[search_index * 5 + 1]) {
      if (c == DEVICE_Hashes_32[search_index * 5 + 2]) {
        if (d == DEVICE_Hashes_32[search_index * 5 + 3]) {
        if (e == DEVICE_Hashes_32[search_index * 5 + 4]) {
        if (pass_length >= 1) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 0] = deviceCharset[p0];
        if (pass_length >= 2) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 1] = deviceCharset[p1 + (256 * 1)];
        if (pass_length >= 3) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 2] = deviceCharset[p2 + (256 * 2)];
        if (pass_length >= 4) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 3] = deviceCharset[p3 + (256 * 3)];
        if (pass_length >= 5) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 4] = deviceCharset[p4 + (256 * 4)];
        if (pass_length >= 6) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 5] = deviceCharset[p5 + (256 * 5)];
        if (pass_length >= 7) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 6] = deviceCharset[p6 + (256 * 6)];
        if (pass_length >= 8) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 7] = deviceCharset[p7 + (256 * 7)];
        if (pass_length >= 9) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 8] = deviceCharset[p8 + (256 * 8)];
        if (pass_length >= 10) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 9] = deviceCharset[p9 + (256 * 9)];
        if (pass_length >= 11) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 10] = deviceCharset[p10 + (256 * 10)];
        if (pass_length >= 12) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 11] = deviceCharset[p11 + (256 * 11)];
        if (pass_length >= 13) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 12] = deviceCharset[p12 + (256 * 12)];
        if (pass_length >= 14) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 13] = deviceCharset[p13 + (256 * 13)];
        if (pass_length >= 15) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 14] = deviceCharset[p14 + (256 * 14)];
        if (pass_length >= 16) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 15] = deviceCharset[p15 + (256 * 15)];
        success[search_index] = (unsigned char) 1;
		}
        }
      }
    }
  }
  search_index++;
  }
  }
  }
  // This is where the goto goes.  Notice the skipping of all the global memory access.
  next:
  ;
}

__device__ inline void checkHashFASTSHA1(int pass_length, uint32_t numberOfPasswords,
		uint32_t *DEVICE_Hashes_32, unsigned char *success, unsigned char *OutputPassword,
		unsigned char p0, unsigned char p1, unsigned char p2, unsigned char p3, 
		unsigned char p4, unsigned char p5, unsigned char p6, unsigned char p7,
		unsigned char p8, unsigned char p9, unsigned char p10, unsigned char p11,
		unsigned char p12, unsigned char p13, unsigned char p14, unsigned char p15,
		UINT4 a, UINT4 b, UINT4 c, UINT4 d, UINT4 e,
		uint32_t &search_index) {

  search_index = 0;  
  while (search_index < numberOfPasswords) {
  if (a == DEVICE_Hashes_32[search_index * 5]) {
    if (b == DEVICE_Hashes_32[search_index * 5 + 1]) {
      if (c == DEVICE_Hashes_32[search_index * 5 + 2]) {
        if (d == DEVICE_Hashes_32[search_index * 5 + 3]) {
        if (e == DEVICE_Hashes_32[search_index * 5 + 4]) {
        
        if (pass_length >= 1) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 0] = deviceCharset[p0];
        if (pass_length >= 2) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 1] = deviceCharset[p1];
        if (pass_length >= 3) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 2] = deviceCharset[p2];
        if (pass_length >= 4) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 3] = deviceCharset[p3];
        if (pass_length >= 5) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 4] = deviceCharset[p4];
        if (pass_length >= 6) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 5] = deviceCharset[p5];
        if (pass_length >= 7) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 6] = deviceCharset[p6];
        if (pass_length >= 8) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 7] = deviceCharset[p7];
        if (pass_length >= 9) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 8] = deviceCharset[p8];
        if (pass_length >= 10) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 9] = deviceCharset[p9];
        if (pass_length >= 11) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 10] = deviceCharset[p10];
        if (pass_length >= 12) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 11] = deviceCharset[p11];
        if (pass_length >= 13) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 12] = deviceCharset[p12];
        if (pass_length >= 14) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 13] = deviceCharset[p13];
        if (pass_length >= 15) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 14] = deviceCharset[p14];
        if (pass_length >= 16) OutputPassword[search_index * MAX_PASSWORD_LENGTH + 15] = deviceCharset[p15];
        success[search_index] = (unsigned char) 1;
		}
        }
      }
    }
  }
  search_index++;
  }
}




